<script setup lang="ts">
import type { BaseHero } from '@/types/base';

defineProps<BaseHero>();
</script>

<template>
  <section class="hero" :class="[config?.theme]">
    <SlpContainer>
      <SlpRow class="wrapper">
        <SlpColumn class="content" :class="[{ 'slp-mb-64': backgroundImage }]">
          <SlpTypography variant="heading5-bold" tag="p" class="hero__title-tagline-highlight">{{
            tagline
          }}</SlpTypography>
          <SlpTypography variant="heading1-bold" tag="h1">
            {{ title }}
          </SlpTypography>
          <SlpTypography v-if="subTitle" class="hero__description" variant="heading5" tag="p">{{
            subTitle
          }}</SlpTypography>
          <div class="hero__buttons" role="group" aria-label="buttons">
            <SlpButton
              :href="secondaryButton.config.href"
              variant="secondary"
              class="button"
              :data-ga-name="secondaryButton.config.dataGaName"
              :data-ga-location="secondaryButton.config.dataGaLocation"
            >
              {{ secondaryButton.text }}
            </SlpButton>
          </div>
        </SlpColumn>
        <SlpColumn cols="6" class="backgroundImage">
          <img :src="backgroundImage.config.src" alt="" />
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.wrapper {
  gap: 32px;
}

.hero {
  position: relative;
  overflow: hidden;
  @media (min-width: $breakpoint-md) {
    padding: $spacing-64 0;
  }

  &.dark {
    background-color: $color-surface-700;
    color: $color-text-50;
  }

  .slp-btn-tertiary {
    color: $color-text-50;
  }

  &.has-image {
    .image {
      img {
        width: 100%;
      }
    }

    .rounded {
      img {
        border-bottom-right-radius: 160px;
      }
    }
  }

  &:not(.has-image) {
    .content {
      width: 100%;
    }
  }

  &__title-tagline-highlight {
    display: block;
    background: linear-gradient(91.08deg, #fca326 -9.03%, #a686f2 27.88%, #a989f5 65.98%);
    background-clip: text;
    -webkit-background-clip: text;
    -webkit-text-fill-color: transparent;
    margin-top: $spacing-48;
    margin-bottom: $spacing-8;
  }

  .image img {
    max-width: 100%;
    height: auto;
    display: block;
  }

  .backgroundImage {
    position: static;
    opacity: 0;
    animation: opacity-intro 0.9s linear forwards 0.9s;
    img {
      position: absolute;
      right: 0;
      top: 36px;
    }
    @media (max-width: 1024px) {
      display: none;
    }
  }

  @keyframes opacity-intro {
    from {
      opacity: 0;
    }
    to {
      opacity: 1;
    }
  }

  &__description {
    margin-top: $spacing-24;
  }

  &__buttons {
    display: flex;
    gap: $spacing-4;
    margin-top: $spacing-24;

    @media (max-width: $breakpoint-sm) {
      flex-direction: column;
    }

    .button {
      @media (max-width: $breakpoint-sm) {
        justify-content: center;
        margin-top: $spacing-8;
      }
    }

    .slp-btn-tertiary {
      padding-left: $spacing-16;
    }
  }
}

.purple-background {
  position: absolute;
  z-index: -1;
  right: 0;
  background-color: $color-surface-800;
  width: 35vw;
  height: 100%;
  top: 0;

  @media (max-width: $breakpoint-md) {
    display: none;
  }
}

.animated {
  opacity: 0;
  transform: translate3d(0, 50%, 0);
  animation: intro-reveal 0.9s ease-out 0.5s forwards;
}

@keyframes intro-reveal {
  from {
    transform: translate3d(0, 50%, 0);
    opacity: 0;
  }
  to {
    transform: translate3d(0, 0, 0);
    opacity: 1;
  }
}

@media (prefers-reduced-motion: reduce) {
  .animated {
    animation: none;
    opacity: 1;
    transform: translate3d(0, 0, 0);
  }
}
</style>
